
source("D:/R_Package_Estimation/MDCEV_Outside_Forecasting/mdcev_gamma_outside_forecast.r");

Data <<- read.table("D:/R_Package_Estimation/MDCEV_Outside_Forecasting/testout.csv", header=T, sep=",");
output <- "D:/R_Package_Estimation/MDCEV_Outside_Forecasting/testout_gamma.csv";

# path for the dataset that draws pesudo random Halton draws to generate the gumbel error terms
# If you do not have the matrix, you can comment out this line and write code to generate random numbers on the fly
# alternatively, you can uncomment this line and set _gumbel = 0 to avoid considering the unobserved heterogeneity
Halton_File <<- "D:/R_Package_Estimation/Halton/halton_class15.csv";

ivuno <- "uno";         # Column of ones
ivsero <- "sero";       # Column of zeros

numout <- 1;      # Number of outside goods (i.e., always consumed goods)
config <- 4;      # Utility specification configuration, possible values: 4,5,6,7
alp0to1 <<- 1;    # 1 if you want the Alpha values to be constrained between 0 and 1, 0 otherwise
price <- 0;       # 1 if there is price variation across goods, 0 otherwise
nc <<- 3;         # Number of alternatives (in the universal choice set) including outside goods
po <<- 1;         # position of pointer to case number in data set,

nrep <- 1;        # Number of sets of error term Halton draws overwhich you want to simulate the unobserved heterogeneity

# 1 if Gumbel error terms are used to simulate the unobserved heterogeneity (i.e., the error terms), 
# 0 if no error terms are used for forecasting.
# if _gumbel = 0, then set nrep = 1.
gumbel <- 1;
halton_startrow <- 22; # Number of row in dataset of pesudo random halton. It will read halton data from the row number

tolel <- 0.00000001;
tolee <- 0.01;
avg <- 0;

# Provide labels of dependent variables (i.e., the expenditure variables) below
def <- c("consume1","consume2","consume3");

# Provide labels of price variables below; if no price variables, introduce UNO as the variable
fp <- c(ivuno, ivuno, ivuno); #, ivuno, ivuno, ivuno, ivuno, ivuno, ivuno, ivuno, ivuno, ivuno, ivuno, ivuno, ivuno);


# definition of independent variables 
# ivmt[[1]] has variables that influence baseline preference parameter psi, ivd1 has variables that influence the satiation parameter delta, 
# and ivgt[[1]] has variabels that influence the translation parameter gamma; first numout goods are those always consumed, and first good is numeraire  
# Since gamma=0 for the outside goods, the first numout columns of the ivg vectors will be uno or sero, with no other independent variables in these first numout colums 
# ivmt and ivmtc for the outside goods should be c("") and c(0.0) in first columns. 
# For example, if there are two outside goods, ivmt[[1]] = c("") and ivmt[[2]] = c(""). ivmtc[[1]] = c(0.0) and ivmtc[[2]] = c(0.0).
ivmt <- list();
ivmtc <- list();

ivmt[[1]] <- c("");       
ivmtc[[1]] <- c(0.0);   
ivmt[[2]] <- c("uno","hhsize");
ivmtc[[2]] <- c(-6.89,-0.244);
ivmt[[3]] <- c("uno","hhsize");
ivmtc[[3]] <- c(-7.382,-0.024);


# Important Note: For the satiation parameters (alphas and gammas) do not provide the final values of alphas and gammas. 
# Provide the values of the parameters that are actually estimated in the model. 
# For example, gamma is parameterized as exp(theeta), and theeta is estimated. So provide the theeta values here.
# Simialrly, Alpha is parameterized as 1-(1/exp(delta)). Provide the delta values here.
ivdt <- list();

ivdt[[1]] <- c("uno");
ivdt[[2]] <- c("uno");
ivdt[[3]] <- c("uno");


# The Aplph values for all alternatives are restricted to zero. So, it should be -1000 because Exp(-1000) is zero.  
ivdtc <- c(-1000.0);    


ivgt <- list();
ivgtc <- list();

ivgt[[1]] <- c("sero");    # Only one "sero" for each output good should be entered
ivgtc[[1]] <- c(-1000.0);  # Because exp(-1000) is zero, -1000 should be typed for the coefficient of outside good(s)
ivgt[[2]] <- c("uno");
ivgtc[[2]] <- c(6.9506);   # ln(1043.791) = 6.9506
ivgt[[3]] <- c("uno");
ivgtc[[3]] <- c(5.4428);   # ln(231.079) = 5.4428


########################################################################################################
#  Do Not Modify Next Three Lines
########################################################################################################
arg_inds <- list(numout, config, alp0to1, price, nc, po, ivuno, ivsero, nrep, gumbel, halton_startrow, tolel, tolee, avg);
arg_vars <- list(Halton_File, output);
result <- gamma_outside_forecast(Data, arg_inds, arg_vars, def, fp, ivmt, ivdt, ivgt, ivmtc, ivdtc, ivgtc);
########################################################################################################